--Bob Minimap, modification of Quilight's qMinimap
local _, cfg = ... --import config
local addon, ns = ... --get addon namespace
local isBeautiful = IsAddOnLoaded("!Beautycase") --!Beautycase check

Minimap:ClearAllPoints()
Minimap:SetPoint(unpack(cfg.minimap.position))
Minimap:SetSize(cfg.minimap.width, cfg.minimap.height)

local dummy = function() end
local _G = getfenv(0)
-----------------------------------------------
--Setting up the buttons
-----------------------------------------------
-- Hide Border
MinimapBorder:Hide()
MinimapBorderTop:Hide()
-- Hide Zoom Buttons
MinimapZoomIn:Hide()
MinimapZoomOut:Hide()
-- Hide Voice Chat Frame
MiniMapVoiceChatFrame:Hide()
-- Hide North texture at top
MinimapNorthTag:SetTexture(nil)
-- Hide Zone Frame
MinimapZoneTextButton:Hide()
-- Hide Calendar Button
GameTimeFrame:Hide()
MinimapCluster:EnableMouse(false)
--Tracking Button
MiniMapTrackingBackground:SetAlpha(0)
MiniMapTrackingButton:SetAlpha(0)
MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("BOTTOMRIGHT", Minimap, 0, 0)
MiniMapTracking:SetScale(1)
-- Hide world map button
MiniMapWorldMapButton:Hide()
-- Reposition lfg icon at bottom-left
QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", 2, 1)
QueueStatusMinimapButtonBorder:Hide()
--Mail Icon
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("TOPRIGHT", Minimap, 0, 0)
MiniMapMailFrame:SetFrameStrata("LOW")
MiniMapMailIcon:SetTexture("Interface\\AddOns\\BobUI\\media\\mail.tga")
MiniMapMailBorder:Hide()
---Hide Instance Difficulty flag
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:Hide()

WorldMapPlayerUpper:EnableMouse(false)
WorldMapPlayerLower:EnableMouse(false)

-- Enable mouse scrolling
Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(self, d)
	if d > 0 then
		_G.MinimapZoomIn:Click()
	elseif d < 0 then
		_G.MinimapZoomOut:Click()
	end
end)

-- Set Square Map Mask
Minimap:SetMaskTexture('Interface\\ChatFrame\\ChatFrameBackground')
--Hide the blob ring
Minimap:SetArchBlobRingScalar(0)
Minimap:SetQuestBlobRingScalar(0)

--Create minimap border
if isBeautiful then
	Minimap:CreateBeautyBorder(cfg.bordersize.large)
	Minimap:SetBeautyBorderPadding(2)
	Minimap:SetBeautyBorderTexture(cfg.BorderTexture)
end

--Clock
if cfg.Clock then
--Cause we care about class colors?
local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
if not IsAddOnLoaded("Blizzard_TimeManager") then
	LoadAddOn("Blizzard_TimeManager")
end
local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
clockFrame:Hide()
clockTime:SetFont(cfg.font, cfg.time.fontsize, cfg.style)
clockTime:SetTextColor(playerColor.r, playerColor.g, playerColor.b)
TimeManagerClockButton:SetPoint(unpack(cfg.time.position))
clockTime:Show()
end

-- Zone text
if cfg.ZoneText then
	local zoneTextFrame = CreateFrame("Frame", nil, UIParent)
	zoneTextFrame:SetPoint(unpack(cfg.zone.position))
	zoneTextFrame:SetSize(100,cfg.zone.fontsize)
	MinimapZoneText:SetParent(zoneTextFrame)
	MinimapZoneText:ClearAllPoints()
	MinimapZoneText:SetPoint(unpack(cfg.zone.position))
	MinimapZoneText:SetJustifyH(cfg.zone.justify)
	MinimapZoneText:SetFont(cfg.font, cfg.zone.fontsize, cfg.style)
end

--Watch Frame
if cfg.WatchFrame then
WatchFrameCollapseExpandButton:ClearAllPoints()
WatchFrameCollapseExpandButton.ClearAllPoints = function() end
WatchFrameCollapseExpandButton:SetPoint("BOTTOMLEFT", Minimap, 0,0)
WatchFrameCollapseExpandButton:SetAlpha(0)
WatchFrameCollapseExpandButton:SetFrameStrata("MEDIUM")
WatchFrameCollapseExpandButton:SetFrameLevel(2)

local function init()
    local wf = _G['WatchFrame']
    wf:ClearAllPoints()	
    wf.ClearAllPoints = function() end
    wf:SetPoint(unpack(cfg.watch.position))
    wf.SetPoint = function() end
    wf:SetHeight(cfg.watch.height)  
	wf:SetFrameStrata("LOW")
end
local a = CreateFrame("Frame")
a:SetScript("OnEvent", function(self, event)
	if(event=="PLAYER_LOGIN") then
		init()
    end
end)
a:RegisterEvent("PLAYER_LOGIN")
local f = CreateFrame("Frame")

--Collapse Quest Tracker based on zone
if cfg.watch.combatcollaps then
	local nWFA = CreateFrame("Frame")
		function nWFA.UpdateCollapseState()
			if not WF then WF = _G["WatchFrame"] end
			if not Opts.hidden.enabled then return end
			
			local Inst, InstType = IsInInstance()
			local Collapsed = false
			if Inst then
				if (InstType == "pvp" and Opts.hidden.collapse.pvp) then			-- Battlegrounds
					Collapsed = true
				elseif (InstType == "arena" and Opts.hidden.collapse.arena) then	-- Arena
					Collapsed = true
				elseif (InstType == "party" and Opts.hidden.collapse.party) then	-- 5 Man Dungeons
					Collapsed = true
				elseif (InstType == "raid" and Opts.hidden.collapse.raid) then	-- Raid Dungeons
					Collapsed = true
				end
			end
			
			if Collapsed then
				WF.userCollapsed = true
				WatchFrame_Collapse(WF)
			else
				WF.userCollapsed = false
				WatchFrame_Expand(WF)
			end	
		end
	end
end